/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.DropCoords;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.GroupLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.components.FloatFormattedTextField;
import static org.visnow.vn.lib.basic.filters.DropCoords.DropCoordsShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p)
    {
        final float[] margins = p.get(ORIGIN);
        final float[] cellSizes = p.get(CELL_SIZES);
        final int rank = p.get(META_FIELD_RANK);

        SwingUtilities.invokeLater(new Runnable()
        {
            @Override
            public void run()
            {
                cellXField.setText(Float.toString(cellSizes[0]));
                cellYField.setText(Float.toString(cellSizes[1]));
                cellZField.setText(Float.toString(cellSizes[2]));
                cellZField.setEnabled(rank > 2);
                cellYField.setEnabled(rank > 1);
                origXField.setText(Float.toString(margins[0]));
                origYField.setText(Float.toString(margins[1]));
                origZField.setText(Float.toString(margins[2]));
                origZField.setEnabled(rank > 2);
                origYField.setEnabled(rank > 1);

            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        GridBagConstraints gridBagConstraints;

        cellXField = new FloatFormattedTextField();
        cellYField = new FloatFormattedTextField();
        cellZField = new FloatFormattedTextField();
        origXField = new FloatFormattedTextField();
        origYField = new FloatFormattedTextField();
        origZField = new FloatFormattedTextField();
        jLabel1 = new JLabel();
        jLabel2 = new JLabel();
        jLabel3 = new JLabel();
        jLabel4 = new JLabel();
        jLabel5 = new JLabel();
        jLabel6 = new JLabel();
        jPanel1 = new JPanel();

        setLayout(new GridBagLayout());

        cellXField.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                cellXFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(cellXField, gridBagConstraints);

        cellYField.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                cellYFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        add(cellYField, gridBagConstraints);

        cellZField.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                cellZFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new Insets(0, 0, 10, 0);
        add(cellZField, gridBagConstraints);

        origXField.setText("0");
        origXField.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                origXFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        add(origXField, gridBagConstraints);

        origYField.setText("0");
        origYField.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                origYFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        add(origYField, gridBagConstraints);

        origZField.setText("0");
        origZField.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                origZFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        add(origZField, gridBagConstraints);

        jLabel1.setText("cell x size");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        gridBagConstraints.insets = new Insets(0, 0, 0, 21);
        add(jLabel1, gridBagConstraints);

        jLabel2.setText("cell y size");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        add(jLabel2, gridBagConstraints);

        jLabel3.setText("cell z size");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        gridBagConstraints.insets = new Insets(0, 0, 13, 0);
        add(jLabel3, gridBagConstraints);

        jLabel4.setText("origin x");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        add(jLabel4, gridBagConstraints);

        jLabel5.setText("origin y");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        add(jLabel5, gridBagConstraints);

        jLabel6.setText("origin z");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        add(jLabel6, gridBagConstraints);

        GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 178, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 176, Short.MAX_VALUE)
        );

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.4;
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void cellXFieldActionPerformed(ActionEvent evt)//GEN-FIRST:event_cellXFieldActionPerformed
    {//GEN-HEADEREND:event_cellXFieldActionPerformed
        updateParams();
    }//GEN-LAST:event_cellXFieldActionPerformed

    private void cellYFieldActionPerformed(ActionEvent evt)//GEN-FIRST:event_cellYFieldActionPerformed
    {//GEN-HEADEREND:event_cellYFieldActionPerformed
        updateParams();
    }//GEN-LAST:event_cellYFieldActionPerformed

    private void cellZFieldActionPerformed(ActionEvent evt)//GEN-FIRST:event_cellZFieldActionPerformed
    {//GEN-HEADEREND:event_cellZFieldActionPerformed
        updateParams();
    }//GEN-LAST:event_cellZFieldActionPerformed

    private void origXFieldActionPerformed(ActionEvent evt)//GEN-FIRST:event_origXFieldActionPerformed
    {//GEN-HEADEREND:event_origXFieldActionPerformed
        updateParams();
    }//GEN-LAST:event_origXFieldActionPerformed

    private void origYFieldActionPerformed(ActionEvent evt)//GEN-FIRST:event_origYFieldActionPerformed
    {//GEN-HEADEREND:event_origYFieldActionPerformed
        updateParams();
    }//GEN-LAST:event_origYFieldActionPerformed

    private void origZFieldActionPerformed(ActionEvent evt)//GEN-FIRST:event_origZFieldActionPerformed
    {//GEN-HEADEREND:event_origZFieldActionPerformed
        updateParams();
    }//GEN-LAST:event_origZFieldActionPerformed

    private void updateParams()
    {
        parameters.set(CELL_SIZES, new float[]{cellXField.getValue(), cellYField.getValue(), cellZField.getValue()},
                       ORIGIN, new float[]{origXField.getValue(), origYField.getValue(), origZField.getValue()});
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private FloatFormattedTextField cellXField;
    private FloatFormattedTextField cellYField;
    private FloatFormattedTextField cellZField;
    private JLabel jLabel1;
    private JLabel jLabel2;
    private JLabel jLabel3;
    private JLabel jLabel4;
    private JLabel jLabel5;
    private JLabel jLabel6;
    private JPanel jPanel1;
    private FloatFormattedTextField origXField;
    private FloatFormattedTextField origYField;
    private FloatFormattedTextField origZField;
    // End of variables declaration//GEN-END:variables
}
